package com.yunzhi.niucai.service;

import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.yunzhi.niucai.entity.TaBettingPlan;
import com.yunzhi.niucai.entity.TaCustomerBetting;
import com.yunzhi.niucai.entity.TaOrder;
import com.baomidou.mybatisplus.extension.service.IService;
import com.yunzhi.niucai.entity.TaShop;
import com.yunzhi.niucai.vo.DrawOrderParam;

/**
 * <p>
 * 订单主表  服务类
 * </p>
 *
 * @author yansen
 * @since 2020-09-09
 */
public interface ITaOrderService extends IService<TaOrder> {

    TaOrder bettingOrder(TaBettingPlan taBettingPlan, TaCustomerBetting taCustomerBetting) throws Exception;

    IPage<TaOrder> getShopOrders(IPage<TaOrder> pg, TaShop taShop, String lotteryId) throws Exception;

    TaOrder getShopOrderDetail(TaShop taShop, String orderId) throws Exception;

    boolean drawOrder(TaOrder taOrder, DrawOrderParam drawOrderParam) throws Exception;

    TaOrder getByOutTradeNo(String outTradeNo);

    TaOrder getByBetting(TaCustomerBetting betting) throws Exception;

    /**
     * 转账结果提醒
     * https://opendocs.alipay.com/apis/msgapi_60/alipay.fund.trans.order.changed
     * @param transRes
     * @throws Exception
     */
    void fundTransNotify(JSONObject transRes) throws Exception;
}
